diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicConduit.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicConduit.java
index cb86b616d..ba134cfca 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicConduit.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicConduit.java
@@ -479,30 +456,207 @@ public class BlockLogicConduit extends BlockLogic {
         return false;
     }
 
+    private static int getUpperNibble(int data) {
+        return (data >> POWER_SHIFT) & POWER_MASK;
+    }
+
+    private static int capSideIndex(int data) {
+        if ((data & STATE_MASK) != 0) return -1;
+        int sideBits = getUpperNibble(data) & CAP_SIDE_MASK;
+        return (sideBits >= 1 && sideBits <= 6) ? sideBits - 1 : -1;
+    }
+
+    /**
+     * Raw stored power for the given data, without resolving caps or inert markers.
+     */
+    public static int getPower(int data) {
+        if ((data & STATE_MASK) != 0) return getUpperNibble(data);
+        if (isCap(data)) return isCapPowered(data) ? 1 : 0;
+        return 0;
+    }
+
+    /**
+     * Power for the conduit at the given position.
+     */
+    public static int getPower(@NotNull WorldSource world, @NotNull TilePosc tilePos) {
+        int data = world.getBlockData(tilePos);
+        if (isCap(data)) {
+            if (!isCapPowered(data)) return 0;
+            int signal = getAndConvertNeighborSignal(world, tilePos, getCapSide(data));
+            return signal > 0 ? signal : PROPAGATION_LENGTH;
+        }
+        if (isInert(data)) return PROPAGATION_LENGTH;
+        return getPower(data);
+    }
+
+    public static boolean isInert(int data) {
+        return (data & STATE_MASK) == 0 && getUpperNibble(data) == INERT_MARKER;
+    }
+
+    public static int makeCap(@NotNull Side side, boolean powered) {
+        int nibble = (powered ? CAP_POWERED : 0) | (side.id + 1);
+        return (nibble << POWER_SHIFT);
+    }
+
+    public static @NotNull Side getCapSide(int data) {
+        return Side.fromId(capSideIndex(data));
+    }
+
+    public static boolean isCapPowered(int data) {
+        return (getUpperNibble(data) & CAP_POWERED) != 0;
+    }
+
+    public static boolean isCap(int data) {
+        return capSideIndex(data) >= 0;
+    }
+
+    public static int withPower(int data, int newPower) {
+        int state = data & STATE_MASK;
+        if (state != 0) {
+            int p = Math.max(0, Math.min(POWER_MASK, newPower));
+            return (p << POWER_SHIFT) | state;
+        }
+        if (isCap(data)) {
+            return makeCap(getCapSide(data), newPower > 0);
+        }
+        return data;
+    }
+
+    private static int connectTowardPlayer(@NotNull Side anchor, @NotNull Side sideFacingPlayer) {
+        if (anchor == sideFacingPlayer) {
+            return makeCap(anchor, false);
+        }
+        return getStateFromTwoSides(anchor, sideFacingPlayer);
+    }
+
+    private static int connectionPriority(@NotNull World world, @NotNull TilePosc cTilePos, @NotNull Side side) {
+        TilePos nTilePos = new TilePos(cTilePos.x() + side.offsetX(), cTilePos.y() + side.offsetY(), cTilePos.z() + side.offsetZ());
+        Block<?> nBlock = world.getBlockType(nTilePos);
+        int nData = world.getBlockData(nTilePos);
+        var logic = nBlock.getLogic();
+        Side against = side.opposite();
+
+        // TODO should probably make connections handled per block rather then by the conduit itself.
+        //  Held off for now as the exact same issue occurs in redstone dust, and should be handled together.
+
+        if (nBlock == Blocks.CONDUIT) {
+            if (isInert(nData)) return CONNECT_NONE;
+            return isSideOpen(nData, against) ? CONNECT_CONDUIT : CONNECT_NONE;
+        }
+        if (logic instanceof BlockLogicPistonHead) {
+            return CONNECT_NONE;
+        }
+        if (logic instanceof BlockLogicPistonBase) {
+            Side head = Direction.fromId(PistonCommon.DIRECTION.get(nData)).side();
+            return head == against ? CONNECT_NONE : CONNECT_PISTON;
+        }
+        if (logic instanceof BlockLogicActivator) {
+            Side face = BlockLogicVeryRotatable.metaToDirection(nData).side();
+            return face == against ? CONNECT_NONE : CONNECT_ACTIVATOR;
+        }
+        if (logic instanceof BlockLogicDispenser) {
+            Side face = BlockLogicVeryRotatable.metaToDirection(nData).side();
+            return face == against ? CONNECT_NONE : CONNECT_DISPENSER;
+        }
+        if (logic instanceof BlockLogicMotionSensor) {
+            Side face = BlockLogicVeryRotatable.metaToDirection(nData).side();
+            return face == against ? CONNECT_NONE : CONNECT_MOTION_SENSOR;
+        }
+        if (nBlock == Blocks.WIRE_REDSTONE) {
+            return CONNECT_REDSTONE_DUST;
+        }
+        if (logic instanceof BlockLogicPumpkinRedstone) {
+            Side face = BlockLogicVeryRotatable.metaToDirection(nData).side();
+            return face == against ? CONNECT_REDSTONE_LANTERN : CONNECT_NONE;
+        }
+        if (nBlock == Blocks.BLOCK_REDSTONE) {
+            return CONNECT_REDSTONE_BLOCK;
+        }
+        if (logic instanceof BlockLogicRepeater) {
+            Side axis = BlockLogicRepeater.getSideFromMeta(nData);
+            return (side == axis || side == axis.opposite()) ? CONNECT_REPEATER : CONNECT_NONE;
+        }
+        if (logic instanceof BlockLogicTimer) {
+            Side axis = BlockLogicTimer.getSideFromMeta(nData);
+            return (side == axis || side == axis.opposite()) ? CONNECT_TIMER : CONNECT_NONE;
+        }
+        if (nBlock == Blocks.MATCHER || nBlock == Blocks.MATCHER_ACTIVE) {
+            return (side.axis() != BlockLogicAxisAligned.metaToAxis(nData)) ? CONNECT_MATCHER : CONNECT_NONE;
+        }
+        if (logic instanceof BlockLogicTorchRedstone) {
+            return CONNECT_TORCH;
+        }
+        if (logic instanceof BlockLogicLever) {
+            return CONNECT_LEVER;
+        }
+        if (logic instanceof BlockLogicButton) {
+            return CONNECT_BUTTON;
+        }
+        if (nBlock == Blocks.SPIKES) {
+            return CONNECT_SPIKES;
+        }
+        if (nBlock == Blocks.NOTEBLOCK) {
+            return CONNECT_NOTEBLOCK;
+        }
+        if (nBlock == Blocks.RAIL_POWERED) {
+            return CONNECT_RAIL_POWERED;
+        }
+        return CONNECT_NONE;
+    }
+
+    private static int tiebreakRank(@NotNull Side side, @NotNull Side sideClickedAgainst, @NotNull Side sideFacingPlayer) {
+        if (side == sideClickedAgainst) return 0;
+        if (side == sideFacingPlayer) return 1;
+        return 2;
+    }
+
     /**
      * Determines which sides on a given conduit are open. <div></div>
      *      c = conduit (ex. cStrength = this conduit Signal Strength) <div></div>
      * @param cData The metadata of the conduit to check.
-     * @return a {@link Side} {@link Array} of sides that are open.
+     * @return a {@link Side} array of the sides that are open.
      */
     public static Side[] getOpenSides(int cData){
-        return STATE_TABLE[cData & STATE_MASK];
+        int state = cData & STATE_MASK;
+        if (state != 0) return STATE_TABLE[state];
+
+        int capSide = capSideIndex(cData);
+        return capSide >= 0 ? CAP_SIDES[capSide] : STATE_TABLE[0];
     }
 
     /**
      * Converts signal strengths between redstone and conduit.
      * @param strength The signal strength to convert
-     * @param conduitToRedstone Whether to convert conduit -> redstone or vice versa
      * @return The converted signal strength
      */
-    public static int signalConverter(int strength, boolean conduitToRedstone) {
+    public static int signalConverter(int strength) {
         return Math.max(0, Math.min(PROPAGATION_LENGTH, strength));
     }
 
     @Override
-    protected int getMatcherEquivalenceData(int data) {
-        if ((data & STATE_MASK) == 0) assert getOpenSides(data).length == 0;
-        else data |= STATE_MASK;
-        return data;
+    public boolean isEquivalent(@NotNull WorldSource world, @NotNull TilePosc thisPos, @NotNull TilePosc thatPos, @NotNull Block<?> thatBlock) {
+        if (!super.isEquivalent(world, thisPos, thatPos, thatBlock)) return false;
+        if (isCap(world.getBlockData(thisPos))) {
+            return getPower(world, thisPos) == getPower(world, thatPos);
+        }
+        return true;
+    }
+
+    @Override
+    public boolean isEquivalentDataForMatcherImpl(int thisData, int thatData) {
+        return getMatcherShape(thisData) == getMatcherShape(thatData)
+                && getMatcherPower(thisData) == getMatcherPower(thatData);
+    }
+    private static int getMatcherShape(int data) {
+        int state = data & STATE_MASK;
+        if (state != 0) {
+            return (state <= 3) ? SHAPE_STRAIGHT : SHAPE_CORNER;
+        }
+        return isCap(data) ? SHAPE_CAPPED : SHAPE_CLOSED;
+    }
+
+    private static int getMatcherPower(int data) {
+        if (isInert(data)) return PROPAGATION_LENGTH;
+        return getPower(data);
     }
 }
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsPumpkin.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsPumpkin.java
index e042cb912..df84bf46c 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsPumpkin.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsPumpkin.java
@@ -3,7 +3,7 @@ package net.minecraft.core.block;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
-import net.minecraft.core.item.IBonemealable;
+// import net.minecraft.core.item.IBonemealable;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.util.helper.Side;
@@ -20,7 +20,7 @@ import java.util.Random;
 
 public class BlockLogicCropsPumpkin
     extends BlockLogicFlower
-    implements IBonemealable {
+    /*implements IBonemealable*/ {
     public BlockLogicCropsPumpkin(final @NotNull Block<?> block) {
         super(block);
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsWheat.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsWheat.java
index 9b2fdfbd6..1b6e4ac01 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsWheat.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsWheat.java
@@ -5,7 +5,7 @@ import java.util.Random;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
-import net.minecraft.core.item.IBonemealable;
+// import net.minecraft.core.item.IBonemealable;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
@@ -16,7 +16,7 @@ import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public class BlockLogicCropsWheat extends BlockLogicFlower implements IBonemealable {
+public class BlockLogicCropsWheat extends BlockLogicFlower /*implements IBonemealable*/ {
     public static final int MASK_GROWTH = 0b0000_0111;
     public static final int MAX_GROWTH_STATE = 7;
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicDispenser.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDispenser.java
index 55e368fea..faacd85aa 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicDispenser.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDispenser.java
@@ -27,11 +27,6 @@ import org.joml.Vector3dc;
 public class BlockLogicDispenser extends BlockLogicVeryRotatable {
     public static final int MASK_POWERED = 0b0000_1000;
 
-    @Override
-    protected int getMatcherEquivalenceData(final int data) {
-        return data & MASK_POWERED;
-    }
-
     public BlockLogicDispenser(final @NotNull Block<?> block) {
         super(block, Materials.STONE);
         block.withEntity(TileEntityDispenser::new);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoor.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoor.java
index b9a16b98a..46dd64bbc 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoor.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoor.java
@@ -30,7 +30,7 @@ import java.util.function.Supplier;
 // TODO this needs massive refactor
 public class BlockLogicDoor
     extends BlockLogic
-    implements IPaintable {
+    implements IPaintable/*, BlockLogic.MatcherDataEquivalency*/ {
     public static final int MASK_ROTATION = 0b0000_0011;
     public static final int MASK_OPENED = 0b0000_0100;
     public static final int MASK_HINGE = 0b0000_1000; // 0 == left hinge; 1 == right hinge
@@ -52,24 +52,16 @@ public class BlockLogicDoor
         }
     }
 
-    @Override
-    protected boolean isSameBlockForMatcher(final @NotNull Block<?> other) {
-        if (!(other.getLogic() instanceof BlockLogicDoor otherDoor)) {
-            return false;
-        }
-        return otherDoor.isTop == this.isTop;
-    }
-
-    @Override
-    protected int getMatcherEquivalenceData(int data) {
-        final int MASK_NON_COLOR = MASK_OPENED | MASK_HINGE | MASK_ROTATION;
-        assert (MASK_HINGE >>> 1) == MASK_OPENED;
-        int data2 = data | ((data & MASK_HINGE) >>> 1); // flips the opened bit if hinge bit is set
-        data &= ~MASK_NON_COLOR;
-        data2 &= MASK_NON_COLOR;
-        data |= data2;
-        return data;
-    }
+    // this doesn't actually work that well
+    // @Override
+    // public boolean isEquivalentDataForMatcherImpl(int thisData, int thatData) {
+    //     // assert (MASK_HINGE >>> 1) == MASK_OPENED;
+    //     thisData &= MASK_OPENED | MASK_HINGE;
+    //     thatData &= MASK_OPENED | MASK_HINGE;
+    //     thisData ^= thisData >>> 1;
+    //     thatData ^= thatData >>> 1;
+    //     return (thisData & MASK_OPENED) == (thatData & MASK_OPENED);
+    // }
 
     @Override
     public void onPlacedOnSide(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final double xHit, final double yHit) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoorPainted.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoorPainted.java
index 7e8b34df3..930c49f81 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoorPainted.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoorPainted.java
@@ -19,6 +19,15 @@ public class BlockLogicDoorPainted
         super(block, material, isTop, false, null);
     }
 
+    public static final int MASK_COLOR = 0xF0;
+
+    // @Override
+    // public boolean isEquivalentDataForMatcherImpl(int thisData, int thatData) {
+    //     return 
+    //         (thisData & MASK_COLOR) == (thatData & MASK_COLOR) && 
+    //         super.isEquivalentDataForMatcherImpl(thisData, thatData);
+    // }
+
     @Override
     public @NotNull ItemStack @Nullable [] getBreakResult(final @NotNull World world, final @NotNull EnumDropCause dropCause, final int data, final @Nullable TileEntity tileEntity) {
         return new ItemStack[]{new ItemStack(Items.DOOR_OAK_PAINTED, 1, 15 - (data >> 4 & 0xF))};
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicEdible.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicEdible.java
index 3da2eec24..76a72897d 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicEdible.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicEdible.java
@@ -19,7 +19,8 @@ import org.jetbrains.annotations.Nullable;
 import java.util.function.Supplier;
 
 public abstract class BlockLogicEdible
-    extends BlockLogic {
+    extends BlockLogic 
+    implements BlockLogic.MatcherDataEquivalency {
     private final @NotNull Supplier<@NotNull Item> itemSupplier;
     public int maxBites;
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFarmland.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFarmland.java
index 237696e82..2d3f67923 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFarmland.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFarmland.java
@@ -28,7 +28,7 @@ import java.util.Random;
 
 public class BlockLogicFarmland
     extends BlockLogic
-    implements IBonemealable {
+    implements IBonemealable, BlockLogic.MatcherDataEquivalency {
     public static final int MASK_FERTILIZED = 0b0001_0000;
     public static final int MASK_WET = 0b0000_1111;
 
@@ -246,8 +246,8 @@ public class BlockLogicFarmland
     }
 
     @Override
-    protected int getMatcherEquivalenceData(int data) {
-        if ((data & MASK_WET) != 0) data |= MASK_WET;
-        return data;
+    public boolean isEquivalentDataForMatcherImpl(int thisData, int thatData) {
+        if ((thisData & ~MASK_WET) != (thatData & ~MASK_WET)) return false;
+        return ((thisData & MASK_WET) == 0) == ((thatData & MASK_WET) == 0);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGate.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGate.java
index 11dad2ba7..d25f78220 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGate.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGate.java
@@ -23,7 +23,7 @@ import org.joml.primitives.AABBdc;
 
 public class BlockLogicFenceGate
     extends BlockLogic
-    implements IPaintable {
+    implements IPaintable, BlockLogic.MatcherDataEquivalency.Masked {
     public static final int MASK_DIRECTION = 0b0000_0011;
     public static final int MASK_OPEN = 0b0000_0100;
     public static final int MASK_POWERED = 0b0000_1000;
@@ -33,9 +33,15 @@ public class BlockLogicFenceGate
     }
 
     @Override
-    protected int getMatcherEquivalenceData(final int data) {
-        assert (data & (MASK_POWERED | MASK_OPEN)) != MASK_POWERED : "fence gate should be opened when powered";
-        return data & ~(MASK_DIRECTION | MASK_POWERED);
+    public int getMatcherDataEquivalencyMask() {
+        return ~(MASK_DIRECTION | MASK_POWERED);
+    }
+
+    @Override
+    public boolean isEquivalentDataForMatcherImpl(int thisData, int thatData) {
+        assert (thisData & (MASK_POWERED | MASK_OPEN)) != MASK_POWERED : "fence gate should be opened when powered";
+        assert (thatData & (MASK_POWERED | MASK_OPEN)) != MASK_POWERED : "fence gate should be opened when powered";
+        return BlockLogic.MatcherDataEquivalency.Masked.super.isEquivalentDataForMatcherImpl(thisData, thatData);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFire.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFire.java
index 790404ddc..53b5267a0 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFire.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFire.java
@@ -397,9 +397,4 @@ public class BlockLogicFire
     public void onEntityCollision(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Entity entity) {
         entity.activeFireBlock = this.block;
     }
-
-    @Override
-    protected int getMatcherEquivalenceData(int data) {
-        return 0;
-    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlag.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlag.java
index a6f8badc5..67cd126d4 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlag.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlag.java
@@ -22,7 +22,9 @@ import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.joml.primitives.AABBdc;
 
-public class BlockLogicFlag extends BlockLogic {
+public class BlockLogicFlag extends BlockLogic
+    implements BlockLogic.MatcherEntityEquivalency<TileEntityFlag>
+{
 
     public BlockLogicFlag(@NotNull Block<?> block, @NotNull Material material) {
         super(block, material);
@@ -88,14 +90,14 @@ public class BlockLogicFlag extends BlockLogic {
         return Material.PISTON_DESTROY_ON_PUSH;
     }
 
+    @Override
+    public @NotNull Class<TileEntityFlag> getEntityEquivalencyClass() {
+        return TileEntityFlag.class;
+    }
+
     // TODO: pure color comparison instead of dye index comparison
     @Override
-    public boolean isEquivalent(@NotNull World world, @NotNull TilePosc thisPos, @NotNull TilePosc thatPos) {
-        assert world.getBlockType(thisPos) == this.block;
-        if (world.getBlockType(thatPos) != this.block) return false;
-        if (!(world.getTileEntity(thisPos) instanceof TileEntityFlag thisFlag) ||
-            !(world.getTileEntity(thatPos) instanceof TileEntityFlag thatFlag))
-            return false;
+    public boolean isEquivalentEntityForMatcherImpl(@NotNull TileEntityFlag thisFlag, @NotNull TileEntityFlag thatFlag) {
         if (thisFlag.colorHash != thatFlag.colorHash) return false;
         if (thisFlag.colorHash != ~0) {
             if (thisFlag.flipped != thatFlag.flipped) return false;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlower.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlower.java
index 0faccf85a..f3ab0af12 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlower.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlower.java
@@ -22,7 +22,7 @@ import java.util.Random;
 
 public class BlockLogicFlower
     extends BlockLogic
-    implements IBonemealable {
+    implements IBonemealable, BlockLogic.MatcherDataEquivalency.Masked {
     public static final int MASK_PERMANENT = 0b1000_0000;
 
     public boolean killedByWeather = false;
@@ -161,7 +161,7 @@ public class BlockLogicFlower
     }
 
     @Override
-    protected int getMatcherEquivalenceData(int data) {
-        return data & ~ MASK_PERMANENT;
+    public int getMatcherDataEquivalencyMask() {
+        return ~MASK_PERMANENT;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
index e7428b752..5ffc6f297 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
@@ -238,10 +238,12 @@ public abstract class BlockLogicFluid extends BlockLogic {
     }
 
     @Override
-    protected boolean isSameBlockForMatcher(@NotNull Block<?> other) {
+    protected boolean isEquivalentBlockForMatcher(@NotNull Block<?> other) {
+        if (other == this.block) return true;
         return other.getLogic() instanceof BlockLogicFluid fluid && fluid.material == this.material;
     }
 
+
     public static boolean isStillEquivalentToFlowing(Block<?> block1, Block<?> block2) {
         if (block1 == null || block2 == null) return false;
         if (block1 == block2) return true;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidFlowing.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidFlowing.java
index 29190bc4f..49e10c5e3 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidFlowing.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidFlowing.java
@@ -14,7 +14,7 @@ import it.unimi.dsi.fastutil.ints.IntArrayList;
 import java.util.Arrays;
 import java.util.Random;
 
-public class BlockLogicFluidFlowing extends BlockLogicFluid {
+public class BlockLogicFluidFlowing extends BlockLogicFluid implements BlockLogic.MatcherDataEquivalency {
     int maxCount;
     public final @NotNull Block<?> blockStill;
 
@@ -83,11 +83,12 @@ public class BlockLogicFluidFlowing extends BlockLogicFluid {
             if (b != null) {
                 b.dropWithCause(world, EnumDropCause.WORLD, spreadPos, world.getBlockData(spreadPos), null, null);
             }
-            if (localFlowDecay >= 8) {
-                world.setBlockTypeDataNotify(spreadPos, this.block, localFlowDecay);
-            } else {
-                world.setBlockTypeDataNotify(spreadPos, this.block, localFlowDecay + 8);
-            }
+            world.setBlockTypeDataNotify(spreadPos, this.block, 8);
+            // if (localFlowDecay >= 8) {
+            //     world.setBlockTypeDataNotify(spreadPos, this.block, localFlowDecay);
+            // } else {
+            //     world.setBlockTypeDataNotify(spreadPos, this.block, localFlowDecay + 8);
+            // }
         } else if (localFlowDecay >= 0 && (localFlowDecay == 0 || isFluidBlocking(world, tilePos.down(queryPos)))) {
             final int meta = (localFlowDecay < MAX_SPREAD)
                 ? localFlowDecay + flowDecayMod
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidStill.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidStill.java
index e4ebf706e..896b7daa7 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidStill.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidStill.java
@@ -3,7 +3,6 @@ package net.minecraft.core.block;
 import java.util.Random;
 
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFullyRotatable.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFullyRotatable.java
index b80fefd85..2313016d4 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFullyRotatable.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFullyRotatable.java
@@ -14,11 +14,6 @@ public class BlockLogicFullyRotatable extends BlockLogic {
         super(block, material);
     }
 
-    @Override
-    protected int getMatcherEquivalenceData(final int data) {
-        return data & ~MASK_DIRECTION;
-    }
-
     @Override
     public void onPlacedByMob(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, @NotNull Mob mob, double xHit, double yHit) {
         final Direction direction = mob.getPlacementDirection(side).opposite();
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicGrowthRubyglass.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicGrowthRubyglass.java
index 4e6b54adb..ea739bee2 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicGrowthRubyglass.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicGrowthRubyglass.java
@@ -16,7 +16,7 @@ import org.jetbrains.annotations.Nullable;
 import org.joml.primitives.AABBd;
 import org.joml.primitives.AABBdc;
 
-public class BlockLogicGrowthRubyglass extends BlockLogic {
+public class BlockLogicGrowthRubyglass extends BlockLogic implements BlockLogic.MatcherDataEquivalency.Masked {
 
 	public static final int DIRECTION_MASK = 0b0000_0111;
 	public static final int SHAPE_MASK = 0b0001_1000;
@@ -226,7 +226,7 @@ public class BlockLogicGrowthRubyglass extends BlockLogic {
     }
 
 	@Override
-	protected int getMatcherEquivalenceData(int data) {
-		return data & ~DIRECTION_MASK;
+	public int getMatcherDataEquivalencyMask() {
+		return ~DIRECTION_MASK;
 	}
 }
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicJar.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicJar.java
index ae7d3de80..d59f551d5 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicJar.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicJar.java
@@ -18,7 +18,6 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePosc;
-import net.minecraft.core.world.wind.WindProvider;
 
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -27,7 +26,12 @@ import org.joml.primitives.AABBdc;
 
 import java.util.function.Supplier;
 
-public class BlockLogicJar extends BlockLogic implements ISupportable {
+public class BlockLogicJar extends BlockLogic
+implements 
+    ISupportable,
+    BlockLogic.MatcherDataEquivalency,
+    BlockLogic.MatcherEntityEquivalency<TileEntityFlowerJar>
+{
 
     private final @NotNull Supplier<@NotNull Item> itemSupplier;
 
@@ -137,19 +141,22 @@ public class BlockLogicJar extends BlockLogic implements ISupportable {
     }
 
     @Override
-    public boolean isEquivalent(@NotNull World world, @NotNull TilePosc thisPos, @NotNull TilePosc thatPos) {
-        assert world.getBlockType(thisPos) == this.block;
-        if (world.getBlockType(thatPos) != this.block) return false;
-        final int thisData, thatData; {
-            thisData = world.getBlockData(thisPos);
-            thatData = world.getBlockData(thatPos);
-        }
-        if ((thisData | thatData) == 0) return true;
-        if (!(world.getTileEntity(thisPos) instanceof TileEntityFlowerJar thisFlowerJar) ||
-            !(world.getTileEntity(thatPos) instanceof TileEntityFlowerJar thatFlowerJar))
-            return false;
-        if (thisFlowerJar.flowerInPot != thatFlowerJar.flowerInPot) return false;
-        if (thisFlowerJar.flowerData != thatFlowerJar.flowerData) return false;
-        return true;
+    public boolean isEntityRequiredForMatching() {
+        return false;
+    }
+
+    @Override
+    public @NotNull Class<TileEntityFlowerJar> getEntityEquivalencyClass() {
+        return TileEntityFlowerJar.class;
+    }
+
+    @Override
+    public boolean isEquivalentEntityForMatcherImpl(
+        @Nullable TileEntityFlowerJar thisJar, @Nullable TileEntityFlowerJar thatJar
+    ) {
+        if (thisJar == null || thatJar == null) return thisJar == null && thatJar == null;
+        return 
+            thisJar.flowerInPot == thatJar.flowerInPot &&
+            thisJar.flowerData == thatJar.flowerData;
     }
 }
\ No newline at end of file
